/*
 * <<< r3000_cp0.cc >>>
 *
 * --- R3000 CP0 class 'r3000_cp0'
 *     Copyright (C) 1995-2001 Amano Lab., Keio University. ---
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 */

#include "r3000_cp0.h"

using namespace std;

r3000_cp0::r3000_cp0(void)
{
	reset();
}

r3000_cp0::r3000_cp0(const r3000_cp0& a)
	: rf(a.rf)
{}

r3000_cp0::~r3000_cp0()
{}

void r3000_cp0::reset(void)
{
	rf.clear();
	rf.set_bootstrap_exception_vectors();
	rf.random() = 63;
}

void r3000_cp0::output(ostream& os) const
{
	// os << rf;
#ifdef DEBUG
	os.flush();
#endif // DEBUG
}
