/*
 * <<< root_object.cc >>>
 *
 * --- Abstract root object class 'root_object'
 *     Copyright (C) 1997-2001 Amano Lab., Keio University. ---
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 */

#ifdef DEBUG
# include <cassert>
#endif // DEBUG
#include <iostream>
#include "root_object.h"

using namespace std;

istream& operator>>(istream& is, root_object& a)
{
#ifdef DEBUG
	assert(a.check_invariant());
#endif // DEBUG
	if (is) a.input(is);
	return is;
}

ostream& operator<<(ostream& os, const root_object& a)
{
#ifdef DEBUG
	assert(a.check_invariant());
#endif // DEBUG
	if (os) a.output(os);
#ifdef DEBUG
	os.flush();
#endif // DEBUG
	return os;
}
